Index: subsys/csrss/win32csr/conio.c
===================================================================
--- subsys/csrss/win32csr/conio.c	(revision 12831)
+++ subsys/csrss/win32csr/conio.c	(working copy)
@@ -1127,7 +1127,7 @@
   if (0 == (Console->Mode & ENABLE_LINE_INPUT)
       || Console->EarlyReturn
       || ('\n' == KeyEventRecord->InputEvent.Event.KeyEvent.uChar.AsciiChar
-          && ! KeyEventRecord->InputEvent.Event.KeyEvent.bKeyDown))
+          && KeyEventRecord->InputEvent.Event.KeyEvent.bKeyDown))
     {
       if ('\n' == KeyEventRecord->InputEvent.Event.KeyEvent.uChar.AsciiChar)
         {
Index: subsys/win32k/ntuser/keyboard.c
===================================================================
--- subsys/win32k/ntuser/keyboard.c	(revision 12764)
+++ subsys/win32k/ntuser/keyboard.c	(working copy)
@@ -16,8 +16,7 @@
  *  along with this program; if not, write to the Free Software
  *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  */
-/* $Id$
- *
+/*
  * COPYRIGHT:        See COPYING in the top level directory
  * PROJECT:          ReactOS kernel
  * PURPOSE:          Messages
@@ -342,16 +341,23 @@
 			 HKL dwhkl ) {
   int ToUnicodeResult = 0;
 
-  IntLockQueueState;
-  ToUnicodeResult = ToUnicodeInner( wVirtKey,
-				    wScanCode,
-				    lpKeyState,
-				    pwszBuff,
-				    cchBuff,
-				    wFlags,
-				    PsGetWin32Thread() ? 
-				    PsGetWin32Thread()->KeyboardLayout : 0 );
-  IntUnLockQueueState;
+  if (0 == (lpKeyState[wVirtKey] & KS_DOWN_BIT))
+    {
+      ToUnicodeResult = 0;
+    }
+  else
+    {
+      IntLockQueueState;
+      ToUnicodeResult = ToUnicodeInner( wVirtKey,
+				        wScanCode,
+				        lpKeyState,
+				        pwszBuff,
+				        cchBuff,
+				        wFlags,
+				        PsGetWin32Thread() ? 
+				        PsGetWin32Thread()->KeyboardLayout : 0 );
+      IntUnLockQueueState;
+    }
 
   return ToUnicodeResult;
 }
